commit:     8e3f1d24607966e75cbecad51fdef92d4e9be4e5
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sat Jun 22 16:31:27 2024 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sat Jun 22 16:39:26 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=8e3f1d24

dev-python/pip: Bump to 24.1

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 dev-python/pip/Manifest                          |   1 +
 dev-python/pip/files/pip-24.1-test-offline.patch |  65 +++++++++++
 dev-python/pip/pip-24.1.ebuild                   | 137 +++++++++++++++++++++++
 3 files changed, 203 insertions(+)

diff --git a/dev-python/pip/Manifest b/dev-python/pip/Manifest
index 3116dbf3047d..2fd0cf6f1120 100644
--- a/dev-python/pip/Manifest
+++ b/dev-python/pip/Manifest
@@ -1 +1,2 @@
 DIST pip-24.0.gh.tar.gz 9398156 BLAKE2B 
17a7ed9e15e9b8efa0d3e3c5586dc446958b62cf9ba52155a0d1ad97a3e212ee7a08a0e88a592718fc3d542eb8f434155a75cb98d90c008904bd8f59bd2b40b6
 SHA512 
0c2ecb2ecde4f155c83468d35bc4f52f37efffc16821ae7c706d035e1e8cc3709b41cb10f8140ff09205e8bbdba2c76128ad76d1cbd18401328b619228e834df
+DIST pip-24.1.gh.tar.gz 9188658 BLAKE2B 
4a43ff0199d811dd30461e376f655a447f3f706a48dd97fe1d0ccf630f558e72209ccd06d98949a1541cd6b2942a816db23ce8aaa7fbbf9aef429502fb91ab92
 SHA512 
c60ab329fe91202ff64b5f0f90209085fbf8db0f0a05f0703f952ad69e39e2e3edb5dadc006a3f317cdd4ba4fb5abe56dfbd22792249a2d139702eec272186d1

diff --git a/dev-python/pip/files/pip-24.1-test-offline.patch 
b/dev-python/pip/files/pip-24.1-test-offline.patch
new file mode 100644
index 000000000000..ebbf5a94a1ba
--- /dev/null
+++ b/dev-python/pip/files/pip-24.1-test-offline.patch
@@ -0,0 +1,65 @@
+diff --git a/tests/conftest.py b/tests/conftest.py
+index 35101cef2..5934e9f95 100644
+--- a/tests/conftest.py
++++ b/tests/conftest.py
+@@ -395,6 +395,7 @@ def pip_editable_parts(
+             "-m",
+             "pip",
+             "install",
++            "--no-build-isolation",
+             "--target",
+             pip_self_install_path,
+             "-e",
+diff --git a/tests/functional/test_config_settings.py 
b/tests/functional/test_config_settings.py
+index 3f88d9c39..857722dd1 100644
+--- a/tests/functional/test_config_settings.py
++++ b/tests/functional/test_config_settings.py
+@@ -118,6 +118,7 @@ def test_config_settings_implies_pep517(
+     )
+     result = script.pip(
+         "wheel",
++        "--no-build-isolation",
+         "--config-settings",
+         "FOO=Hello",
+         pkg_path,
+diff --git a/tests/functional/test_install.py 
b/tests/functional/test_install.py
+index eaea12a16..e19446385 100644
+--- a/tests/functional/test_install.py
++++ b/tests/functional/test_install.py
+@@ -685,7 +685,7 @@ def test_link_hash_in_dep_fails_require_hashes(
+     # Build a wheel for pkga and compute its hash.
+     wheelhouse = tmp_path / "wheehouse"
+     wheelhouse.mkdir()
+-    script.pip("wheel", "--no-deps", "-w", wheelhouse, project_path)
++    script.pip("wheel", "--no-build-isolation", "--no-deps", "-w", 
wheelhouse, project_path)
+     digest = hashlib.sha256(
+         wheelhouse.joinpath("pkga-1.0-py3-none-any.whl").read_bytes()
+     ).hexdigest()
+@@ -903,7 +903,7 @@ def 
test_editable_install__local_dir_setup_requires_with_pyproject(
+         "setup(name='dummy', setup_requires=['simplewheel'])\n"
+     )
+ 
+-    script.pip("install", "--find-links", shared_data.find_links, "-e", 
local_dir)
++    script.pip("install", "--no-build-isolation", "--find-links", 
shared_data.find_links, "-e", local_dir)
+ 
+ 
+ def test_install_pre__setup_requires_with_pyproject(
+diff --git a/tests/functional/test_self_update.py 
b/tests/functional/test_self_update.py
+index c50755220..1331a87c3 100644
+--- a/tests/functional/test_self_update.py
++++ b/tests/functional/test_self_update.py
+@@ -11,12 +11,12 @@ def test_self_update_editable(script: Any, pip_src: Any) 
-> None:
+     # Step 1. Install pip as non-editable. This is expected to succeed as
+     # the existing pip in the environment is installed in editable mode, so
+     # it only places a .pth file in the environment.
+-    proc = script.pip("install", pip_src)
++    proc = script.pip("install", "--no-build-isolation", pip_src)
+     assert proc.returncode == 0
+     # Step 2. Using the pip we just installed, install pip *again*, but
+     # in editable mode. This could fail, as we'll need to uninstall the 
running
+     # pip in order to install the new copy, and uninstalling pip while it's
+     # running could fail. This test is specifically to ensure that doesn't
+     # happen...
+-    proc = script.pip("install", "-e", pip_src)
++    proc = script.pip("install", "--no-build-isolation", "-e", pip_src)
+     assert proc.returncode == 0

diff --git a/dev-python/pip/pip-24.1.ebuild b/dev-python/pip/pip-24.1.ebuild
new file mode 100644
index 000000000000..f755b06a67b7
--- /dev/null
+++ b/dev-python/pip/pip-24.1.ebuild
@@ -0,0 +1,137 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+# please bump dev-python/ensurepip-pip along with this package!
+
+DISTUTILS_USE_PEP517=setuptools
+PYTHON_TESTED=( python3_{10..13} )
+PYTHON_COMPAT=( "${PYTHON_TESTED[@]}" pypy3 )
+PYTHON_REQ_USE="ssl(+),threads(+)"
+
+inherit bash-completion-r1 distutils-r1
+
+DESCRIPTION="The PyPA recommended tool for installing Python packages"
+HOMEPAGE="
+       https://pip.pypa.io/en/stable/
+       https://pypi.org/project/pip/
+       https://github.com/pypa/pip/
+"
+SRC_URI="
+       https://github.com/pypa/pip/archive/${PV}.tar.gz -> ${P}.gh.tar.gz
+"
+
+LICENSE="MIT"
+# bundled deps
+LICENSE+=" Apache-2.0 BSD BSD-2 ISC LGPL-2.1+ MPL-2.0 PSF-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86"
+IUSE="test-rust"
+
+RDEPEND="
+       >=dev-python/setuptools-39.2.0[${PYTHON_USEDEP}]
+"
+BDEPEND="
+       ${RDEPEND}
+       test? (
+               $(python_gen_cond_dep '
+                       dev-python/ensurepip-setuptools
+                       dev-python/ensurepip-wheel
+                       dev-python/freezegun[${PYTHON_USEDEP}]
+                       dev-python/pretend[${PYTHON_USEDEP}]
+                       dev-python/pytest-xdist[${PYTHON_USEDEP}]
+                       dev-python/scripttest[${PYTHON_USEDEP}]
+                       dev-python/tomli-w[${PYTHON_USEDEP}]
+                       dev-python/virtualenv[${PYTHON_USEDEP}]
+                       dev-python/werkzeug[${PYTHON_USEDEP}]
+                       dev-python/wheel[${PYTHON_USEDEP}]
+                       test-rust? (
+                               dev-python/cryptography[${PYTHON_USEDEP}]
+                       )
+               ' "${PYTHON_TESTED[@]}")
+       )
+"
+
+distutils_enable_tests pytest
+
+python_prepare_all() {
+       local PATCHES=(
+               "${FILESDIR}/pip-23.1-no-coverage.patch"
+               # https://github.com/pypa/pip/issues/12786 (and more)
+               "${FILESDIR}/pip-24.1-test-offline.patch"
+       )
+
+       distutils-r1_python_prepare_all
+
+       if use test; then
+               local wheels=(
+                       
"${BROOT}"/usr/lib/python/ensurepip/{setuptools,wheel}-*.whl
+               )
+               mkdir tests/data/common_wheels/ || die
+               cp "${wheels[@]}" tests/data/common_wheels/ || die
+       fi
+}
+
+python_compile_all() {
+       # 'pip completion' command embeds full $0 into completion script, which 
confuses
+       # 'complete' and causes QA warning when running as "${PYTHON} -m pip".
+       # This trick sets correct $0 while still calling just installed pip.
+       local pipcmd='import sys; sys.argv[0] = "pip"; __file__ = ""; from 
pip._internal.cli.main import main; sys.exit(main())'
+       "${EPYTHON}" -c "${pipcmd}" completion --bash > completion.bash || die
+       "${EPYTHON}" -c "${pipcmd}" completion --zsh > completion.zsh || die
+}
+
+python_test() {
+       if ! has "${EPYTHON}" "${PYTHON_TESTED[@]/_/.}"; then
+               einfo "Skipping tests on ${EPYTHON}"
+               return 0
+       fi
+
+       local EPYTEST_DESELECT=(
+               tests/functional/test_inspect.py::test_inspect_basic
+               # Internet
+               
tests/functional/test_config_settings.py::test_backend_sees_config_via_sdist
+               tests/functional/test_install.py::test_double_install_fail
+               
tests/functional/test_install_config.py::test_prompt_for_keyring_if_needed
+       )
+       local EPYTEST_IGNORE=(
+               # requires proxy.py
+               tests/functional/test_proxy.py
+       )
+
+       if ! has_version "dev-python/cryptography[${PYTHON_USEDEP}]"; then
+               EPYTEST_DESELECT+=(
+                       
tests/functional/test_install.py::test_install_sends_client_cert
+                       
tests/functional/test_install_config.py::test_do_not_prompt_for_authentication
+                       
tests/functional/test_install_config.py::test_prompt_for_authentication
+                       
tests/functional/test_install_config.py::test_prompt_for_keyring_if_needed
+               )
+       fi
+
+       case ${EPYTHON} in
+               python3.10)
+                       EPYTEST_DESELECT+=(
+                               # no clue why they fail
+                               
tests/unit/test_base_command.py::test_base_command_global_tempdir_cleanup
+                               
tests/unit/test_base_command.py::test_base_command_local_tempdir_cleanup
+                               
tests/unit/test_base_command.py::test_base_command_provides_tempdir_helpers
+                       )
+                       ;;
+       esac
+
+       local -x PIP_DISABLE_PIP_VERSION_CHECK=1
+       local -x PYTEST_DISABLE_PLUGIN_AUTOLOAD=1
+       local EPYTEST_XDIST=1
+       epytest -m "not network" -o tmp_path_retention_policy=all
+}
+
+python_install_all() {
+       local DOCS=( AUTHORS.txt docs/html/**/*.rst )
+       distutils-r1_python_install_all
+
+       newbashcomp completion.bash pip
+
+       insinto /usr/share/zsh/site-functions
+       newins completion.zsh _pip
+}

Reply via email to